﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@


Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private Pane1 As B4XView
	Private TargetX, TargetY As Int
End Sub

Public Sub Initialize
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	For i = 80 To 5 Step - 1
		Dim pnl As B4XView = xui.CreatePanel("")
		pnl.SetColorAndBorder(Rnd(0x8fffffff, 0), 1dip, xui.Color_Black, 5dip)
		pnl.Tag = i
		Pane1.AddView(pnl, 0, 0, 50dip, 50dip)
	Next
	Do While True
		Dim x As Int = TargetX
		Dim y As Int = TargetY
		For Each pnl As B4XView In Pane1.GetAllViewsRecursive
			Dim order As Int = pnl.Tag
			Dim dy As Float = y - pnl.Top
			Dim dx As Float = x - pnl.Left
			Dim alpha As Float = ATan2D(dy, dx)
			Dim dist As Float = Sqrt(Power(dy, 2) + Power(dx, 2))
			Dim speed As Float = Min(order, dist)
			pnl.Left = pnl.Left + CosD(alpha) * speed
			pnl.Top = pnl.Top + SinD(alpha) * speed
			x = pnl.Left
			y = pnl.Top
		Next
		Sleep(30)
	Loop
End Sub

Private Sub Pane1_Touch (Action As Int, X As Float, Y As Float)
	TargetX = X
	TargetY = Y
End Sub